<!--客户loss信息-->
<template>
  <div class="app-container">
    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
          v-hasPermi="['md:loss:add']"
          >新增</el-button
        >
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="success"
          plain
          icon="el-icon-edit"
          size="mini"
          :disabled="single"
          @click="handleUpdate"
          v-hasPermi="['md:loss:edit']"
          >修改</el-button
        >
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="el-icon-delete"
          size="mini"
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['md:loss:remove']"
          >删除</el-button
        >
      </el-col>
      <right-toolbar
        :showSearch.sync="showSearch"
        @queryTable="getList"
      ></right-toolbar>
    </el-row>

    <ClientSelect ref="ClientSelectRef" @onSelected="onClientSelect" />

    <el-table
      v-loading="loading"
      :data="lossList"
      @selection-change="handleSelectionChange"
    >
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="客户名称" align="center" prop="customerName" />
      <el-table-column label="分段数量" align="center" prop="segmentCount" />
      <el-table-column
        label="最大loss数量"
        align="center"
        prop="maxLossCount"
      />
      <el-table-column label="loss比率(单位%)" width="140" align="center" prop="lossRate" />
      <el-table-column label="冗余量" align="center" prop="lossRedundance" />
      <el-table-column label="备注信息" align="center" prop="remark" />
      <el-table-column
        label="操作"
        align="center"
        class-name="small-padding fixed-width"
      >
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['md:loss:edit']"
            >修改</el-button
          >
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
            v-hasPermi="['md:loss:remove']"
            >删除</el-button
          >
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total > 0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改产品loss配置对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="500px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="客户名称" prop="customerName">
          <el-input
            v-model="form.customerName"
            placeholder="请选择客户"
            disabled
          >
            <el-button
              slot="append"
              icon="el-icon-search"
              @click="openClientSelect"
            ></el-button>
          </el-input>
        </el-form-item>
        <el-form-item label="分段数量" prop="segmentCount">
          <el-input v-model="form.segmentCount" placeholder="请输入分段数量" />
        </el-form-item>
        <el-form-item label="最大loss数量" prop="maxLossCount">
          <el-input
            v-model="form.maxLossCount"
            placeholder="请输入最大loss数量"
          />
        </el-form-item>
        <el-form-item label="loss比率(单位%)" prop="lossRate">
          <el-input
            v-model="form.lossRate"
            placeholder="请输入loss比率(单位%)"
          />
        </el-form-item>
        <el-form-item label="冗余量" prop="lossRedundance">
          <el-input v-model="form.lossRedundance" placeholder="请输入冗余量" />
        </el-form-item>
        <el-form-item label="备注信息" prop="remark">
          <el-input v-model="form.remark" placeholder="请输入备注信息" />
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import {
  listLoss,
  getLoss,
  delLoss,
  addLoss,
  updateLoss,
} from "@/api/mes/md/productLoss";
import ClientSelect from "@/components/clientSelect/single.vue";
export default {
  name: "Loss",
  components: {
    ClientSelect,
  },
  data() {
    return {
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 产品loss配置表格数据
      lossList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        itemId: this.itemId,
        customerId: null,
        segmentCount: null,
        maxLossCount: null,
        lossRate: null,
        lossRedundance: null,
        remark: null,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {},
    };
  },
  props: {
    optType: undefined,
    itemId: undefined,
  },
  created() {
    this.getList();
  },
  methods: {
    /** 查询产品loss配置列表 */
    getList() {
      this.loading = true;
      listLoss(this.queryParams).then((response) => {
        this.lossList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        productLossId: null,
        itemId: null,
        customerId: null,
        customerName: null,
        segmentCount: null,
        maxLossCount: null,
        lossRate: null,
        lossRedundance: null,
        remark: null,
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map((item) => item.productLossId);
      this.single = selection.length !== 1;
      this.multiple = !selection.length;
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加产品loss配置";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const productLossId = row.productLossId || this.ids;
      getLoss(productLossId).then((response) => {
        this.form = response.data;
        this.open = true;
        this.title = "修改产品loss配置";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate((valid) => {
        if (valid) {
          if (this.form.productLossId != null) {
            updateLoss(this.form).then((response) => {
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            this.form.itemId = this.itemId;
            addLoss(this.form).then((response) => {
              this.$modal.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },

    onClientSelect(row) {
      if (row != undefined && row != null) {
        this.form.customerId = row.clientId;
        this.form.customerName = row.clientName;
      }
    },
    openClientSelect() {
      this.$refs["ClientSelectRef"].showFlag = true;
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const productLossIds = row.productLossId || this.ids;
      this.$modal
        .confirm(
          '是否确认删除产品loss配置编号为"' + productLossIds + '"的数据项？'
        )
        .then(function () {
          return delLoss(productLossIds);
        })
        .then(() => {
          this.getList();
          this.$modal.msgSuccess("删除成功");
        })
        .catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      this.download(
        "md/loss/export",
        {
          ...this.queryParams,
        },
        `loss_${new Date().getTime()}.xlsx`
      );
    },
  },
};
</script>
